/*
    SDL - Simple DirectMedia Layer
    Copyright (C) 1997-2009 Sam Lantinga

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Sam Lantinga
    slouken@libsdl.org
*/
module org.libsdl.versions;

import org.libsdl.stdinc;

immutable Uint8 SDL_MAJOR_VERSION = 1;
immutable Uint8 SDL_MINOR_VERSION = 2;
immutable Uint8 SDL_PATCHLEVEL    = 14;

struct SDL_version
{
	Uint8 major;
	Uint8 minor;
	Uint8 patch;
}

void SDL_VERSION(ref SDL_version x)
{
	x.major = SDL_MAJOR_VERSION;
	x.minor = SDL_MINOR_VERSION;
	x.patch = SDL_PATCHLEVEL;
}

template SDL_VERSIONNUM(Uint8 major, Uint8 minor, Uint8 patch)
{
	immutable Uint32 SDL_VERSIONNUM = major * 1000 + minor * 100 + patch;
}

immutable Uint32 SDL_COMPILEDVERSION = SDL_VERSIONNUM!(SDL_MAJOR_VERSION, SDL_MINOR_VERSION, SDL_PATCHLEVEL);

bool SDL_VERSION_ATLEAST(Uint8 major, Uint8 minor, Uint8 patch)
{
	return (SDL_COMPILEDVERSION >= major * 1000 + minor * 100 + patch);
}

extern (C)
{
	const(SDL_version)* SDL_Linked_Version();
}
